<?php
    include_once dirname(__FILE__) . '/../components/application.php';
    if (GetApplication()->GetCurrentUserId() == null)
    {
        header('Location: ../login.php');
        exit;
    }
?>

<?php

$sql = 'select field from preset where section = \'database\' and param = \'content\'';
$qry = pg_query($sql);
$ret = pg_fetch_array($qry);
$content = $ret['field'];
if ($content === '')
{
	$content = 'content';
}

$path = "/" . $content . "/Community/";

$datestamp = date('YmdHis');

if (validateDate($_GET['export_datestamp']) and $_GET['export_datestamp'] <> '')
{

	/////////////////////
	// Check Debitor   //
	/////////////////////
	$query_data = "
							SELECT
									count(*) as anz
							FROM         
									invoice i left outer join
									invoice_item ip on ip.nr = i.nr and ip.year = i.year left outer join
									paymenttype p on p.id = i.paymenttype left outer join
									contact c on c.id = i.contact
							WHERE
									printed and not exported and datestamp <= '" . $_GET['export_datestamp'] . "'
									and (
	                                	case when p.debitor is null or p.debitor = '' then c.debitor_id else p.debitor end is null or
	                                    case when p.debitor is null or p.debitor = '' then c.debitor_id else p.debitor end = ''
	                                )										
	";
	
	$err = 0;
	
	$result_data = pg_query($query_data);
	if ($result_data)
	{
		$row = pg_fetch_assoc($result_data);
		if ($row[anz] > 0)
		{
			echo "Fehler: fehlender Debitor in Rechnungen. Bitte kontrollieren Sie die Debitoren in den Rechnungen.<br/>";
			$err=1;
		}
	}
	else
	{
		echo "Fehler: " . $result_data . "<br/>";
		echo pg_last_error();
		$err=1;
	}

}
else
{
	echo "Fehler: Es wurde ein falsches Datumsformat eingegeben.<br/>";	
	$err=1;
}


/////////////////////
// DEBITOR EXPORT
/////////////////////

if ($err == 0)
{

$query_data = "SET CLIENT_ENCODING TO Latin1;";
$result_data = pg_query($query_data);

$fnam = $path.$datestamp.'_debitor.csv';

$query_data = 	"
					copy (		
						SELECT     
								debitor_id AS DebitorNr, 
								LEFT(name1, 40) AS Name1, 
								LEFT(name2, 40) AS Name2, 
								LEFT(uid, 15) AS UidNr, 
						        LEFT(street, 36) AS Strasse, 
								null AS Postfach, 
								LEFT(zip, 10) AS PLZ, 
								LEFT(city, 30) AS Ort
						FROM         
								contact
						WHERE     
								(select count(*) from invoice where invoice.contact = contact.id 
								and datestamp <= '" . $_GET['export_datestamp'] . "' and printed and not exported
								) > 0 and
								debitor_id is not null 
						ORDER BY 
								DebitorNr
						)
					to
					'".$fnam."'
					DELIMITER ';' CSV ENCODING 'Latin1'		
				";

$result_data = pg_query($query_data);

if (!$result_data)
{
	echo "Fehler: " . $result_data . "<br/>";
	echo pg_last_error();
	$err = 1;
}

}


/////////////////////
// INVOICE EXPORT
/////////////////////

if ($err == 0)
{

$fnam = $path.$datestamp.'_buchung.csv';

$query_data = 	"
					copy (
						SELECT
								trim(to_char(abs(sum(ip.gross_amount)), '999999990D00')) AS Betrag, 
								case when sum(ip.gross_amount) >= 0 then 'S' else 'H' end as SollHabenKZ,
								case when p.debitor is null or p.debitor = '' then c.debitor_id else p.debitor end as DebitorNr,
								ip.financial_account AS FibuNr, 
								to_char(i.datestamp, 'ddmmyyyy') as Datum,
								concat(to_char(i.year,'FM9999'),to_char(i.nr, 'FM000000')) as Belegfeld,		
								LEFT(coalesce(i.name1, '') || ' ' || coalesce(i.name2, ''), 30) AS Buchungstext
						FROM         
								invoice i left outer join
								invoice_item ip on ip.nr = i.nr and ip.year = i.year left outer join
								paymenttype p on p.id = i.paymenttype left outer join
								contact c on c.id = i.contact
						WHERE
								printed and not exported and datestamp <= '" . $_GET['export_datestamp'] . "'
						GROUP BY
								i.year,
								i.nr,
								ip.financial_account,
								p.debitor,
								c.debitor_id
						HAVING
								sum(ip.gross_amount) <> 0										
						ORDER BY 
								Belegfeld						
						)
					to
					'".$fnam."'
					DELIMITER ';' CSV ENCODING 'Latin1'
				";

$result_data = pg_query($query_data);
if (!$result_data)
{
	echo "Fehler: " . $result_data . "<br/>";
	echo pg_last_error();
	$err = 1;
}

}

/////////////////////
// MARK INVOICE
/////////////////////

if ($err == 0)
{

$query_data = 	"update invoice set exported = true where printed and not exported and datestamp <= '" . $_GET['export_datestamp'] . "'";
$result_data = pg_query($query_data);
if (!$result_data)
{
	echo "Fehler: " . $result_data . "<br/>";
	echo pg_last_error();
	$err = 1;
}

}


/////////////////////
// MAIL DATA
/////////////////////

if ($err == 0)
{

$sql = 'select field from preset where section = \'mail\' and param = \'sender_name\'';
$qry = pg_query($sql);
$ret = pg_fetch_array($qry);
$absender_name = $ret['field'];

$sql = 'select field from preset where section = \'mail\' and param = \'sender_mail\'';
$qry = pg_query($sql);
$ret = pg_fetch_array($qry);
$absender_email = $ret['field'];


$boundary = strtoupper(md5(uniqid(time())));

$fnam = $datestamp.'_debitor.csv';
$att = $path.$datestamp.'_debitor.csv';
	
$mail_header  = "From: ".$absender_name."<".$absender_email.">\n";
$mail_header .= "Reply-To: ".$absender_email."\n";
$mail_header .= "MIME-Version: 1.0\n";
$mail_header .= "Content-Type: multipart/mixed; boundary=\"".$boundary."\"\n\n";

$mail_msg = "--".$boundary."\n";
$mail_msg .= "Content-Transfer-Encoding: 7bit\n\n";
$mail_msg .= "This is a MIME encoded message.\n";

$mail_msg = "--".$boundary."\n";
$mail_msg .= "Content-Type: text/html; charset=\"utf-8\"\n";
$mail_msg .= "Content-Transfer-Encoding: 8bit\n\n";
$mail_msg .= "<html><head></head><body>Liebes Team!<br><br>Im Anhang finden Sie den aktuellen Buchhaltungsexport für die Buchungen mit der Bitte um Import in die aktuelle Buchhaltung!<br><br>Vielen Dank und liebe Grüße<br><br>" . $absender_name . "</body></html>\n";

$mail_msg .= "--".$boundary."\n";
$mail_msg .= "Content-Type: application/pdf; name=\"".$fnam."\"\n";
$mail_msg .= "Content-Transfer-Encoding: base64\n";
$mail_msg .= "Content-Disposition: attachment; filename=\"".$fnam."\"\n\n";
$mail_msg .= chunk_split(base64_encode(file_get_contents($att)))."\n\n";

$fnam = $datestamp.'_buchung.csv';
$att = $path.$datestamp.'_buchung.csv';
$mail_msg .= "--".$boundary."\n";
$mail_msg .= "Content-Type: application/pdf; name=\"".$fnam."\"\n";
$mail_msg .= "Content-Transfer-Encoding: base64\n";
$mail_msg .= "Content-Disposition: attachment; filename=\"".$fnam."\"\n\n";
$mail_msg .= chunk_split(base64_encode(file_get_contents($att)))."\n\n";

$mail_msg .= "--".$boundary."--";

if (mail($absender_email, 'Buchhaltungsexport', $mail_msg, $mail_header) == false) {
	echo 'Die eMail konnte nicht versendet werden! Bitte die hinterlegte Empfängeradresse prüfen!<br>';
	$error = error_get_last();
	echo "\nERROR: " . $error["message"] ."<br><br>";
}

}

if ($err == 0)
{
	echo "Buchhaltungsexport wurde erzeugt!<br>";
}
else
{
	echo "Buchhaltungsexport wurde nicht erzeugt! Bitte kontrolieren Sie die Fehlermeldung<br>";
}

?>
